<template>
  <PageTemplate v-if="event" v-loading="loading" :data="event" type="event" />
</template>

<script lang="ts">
import { defineComponent, useAsync, useContext } from '@nuxtjs/composition-api'
import { EventFragment } from '@/sdk/types'
import { useGetEventQuery } from '@/sdk/hooks'

import PageTemplate from '@/components/template/PublicPage.vue'

export default defineComponent({
  layout: 'single',
  name: 'EventPage',
  components: { PageTemplate },
  head: {},
  setup(_, { root }) {
    const { app, route, error } = useContext()
    const { onResult, loading } = useGetEventQuery({
      id: root.$route.params.id
    })

    const event = useAsync<EventFragment>(
      () =>
        new Promise(resolve =>
          onResult(result => {
            if (!result?.data?.event) {
              error({ statusCode: 404 })
              return resolve
            }
            const event = result.data.event
            resolve(event)
          })
        )
    )

    if (process.client) {
      onResult(result => {
        if (!result?.data?.event) {
          return error({ statusCode: 404 })
        }
        event.value = result.data.event
      })
    }

    return {
      event,
      loading
    }
  }
})
</script>

<style lang="scss" scoped></style>
